#1906 closed defect (fixed)

CBS scheduler implementation

Reported by: Petr Benes Owned by: Joel Sherrill
Priority: normal Milestone: 4.11
Component: score Version: 4.11
Severity: normal Keywords:
Cc: gedare@…, marta.rybczynska@… Blocked By:
Blocking:

Description

The CBS (Constant Bandwidth Server) scheduler is a complex scheduling policy built atop of the EDF scheduler. Unlike other schedulers, this one provides with an user API and handles not only deadlines of tasks but also claimed budget per period. The main aim of the scheduler is isolation of tasks so that each task is guaranteed to meet all deadlines regardless of how other tasks behave.

2011-09-01 Petr Benes <benesp16@…>

  • sapi/Makefile.am, sapi/include/confdefs.h, sapi/include/rtems/cbs.h,

sapi/inline/rtems/cbs.inl, score/Makefile.am,
score/include/rtems/score/schedulercbs.h, score/src/schedulercbs.c,
score/src/schedulercbsattachthread.c, score/src/schedulercbscleanup.c,
score/src/schedulercbscreateserver.c, score/src/schedulercbsdestroyserver.c,
score/src/schedulercbsdetachthread.c, score/src/schedulercbsgetapprovedbudget.c,
score/src/schedulercbsgetexecutiontime.c, score/src/schedulercbsgetparameters.c,
score/src/schedulercbsgetremainingbudget.c, score/src/schedulercbsgetserverid.c,
score/src/schedulercbsreleasejob.c, score/src/schedulercbssetparameters.c,
score/src/schedulercbsunblock.c: CBS scheduler implementation

Attachments (2)

cbs_scheduler3_noqres.diff (40.8 KB) - added by Petr Benes on Sep 1, 2011 at 8:25:57 PM.
CBS scheduler implementation
cbs_scheduler4.diff (43.0 KB) - added by Petr Benes on Sep 14, 2011 at 7:38:21 PM.
CBS scheduler implementation - version 2

Download all attachments as: .zip

Change History (7)

Changed on Sep 1, 2011 at 8:25:57 PM by Petr Benes

Attachment: cbs_scheduler3_noqres.diff added

CBS scheduler implementation

comment:1 Changed on Sep 1, 2011 at 8:41:35 PM by Petr Benes

blocked: 1907

comment:2 Changed on Sep 12, 2011 at 6:43:41 AM by Marta Rybczynska

Cc: Marta Rybczynska added

Changed on Sep 14, 2011 at 7:38:21 PM by Petr Benes

Attachment: cbs_scheduler4.diff added

CBS scheduler implementation - version 2

comment:3 Changed on Sep 14, 2011 at 7:38:21 PM by Petr Benes

attachments.isobsolete: 01

comment:4 Changed on Sep 15, 2011 at 2:54:19 PM by Joel Sherrill

Resolution: fixed
Status: newclosed

Merged with some warnings fixed.

Thanks.

Doxygen warning logs will show up in http://www.rtems.org/onlinedocs/doxygen/doxy.log. Doxygen is run every 12 hours (0630 and 1230 Huntsville time)

comment:5 Changed on Nov 24, 2014 at 6:58:28 PM by Gedare Bloom

Version: HEAD4.11

Replace Version=HEAD with Version=4.11 for the tickets with Milestone >= 4.11

Note: See TracTickets for help on using tickets.